//  ATiny2313  indic22mega8 
//  :  0  
//ATiny2313
//     

#include <TINY2313.H>
#include <delay.h>

unsigned char number[] = 
{
  0b00111111, //0   0b00111111
  0b00000110, //1   0b00000110
  0b01011011, //2   0b01011011
  0b01001111, //3   0b01001111
  0b01100110, //4   0b01100110
  0b01101101, //5   0b01101101
  0b01111101, //6   0b01111101
  0b00000111, //7   0b00000111
  0b01111111, //8   0b01111111
  0b01101111,  //9   0b01101111 
  0b00111111
};

//    
unsigned char data_e=0;   //1  
unsigned char data_d=0;   //2  
unsigned char count=0;

//  0 -   
interrupt [TIM0_OVF] void Timer0Ovf(void)
{
  //  
   PORTD.0=PORTD.1=1;            //..  1
   //  
   if (count==0) 
    {
      PORTB=number[data_d];     // 
     PORTD.1=~PORTD.1;          //
    }       
   
   if (count==1) 
    {
      PORTB=number[data_e]; 
      PORTD.0=~PORTD.0;         //
    }                         
    count++;
    
    if (count==2) count=0;
   TCNT0=175;  //178
}

void main( void )
{
  //,   . 
   DDRB=0b11111111;        //0b11111111
  PORTB=0b00000000;        //0b11111111
  
  //,   . 
   DDRD=0b0000011;       //PD.0,PD.1  
  PORTD=0b1100000;       //PIND.5 . 
                         //PIND.6 . 
  //  0              
  TIMSK=0b00000010;             // . 0 bit 1  
  TCCR0B=0b00000101;            //  4000/1024=3,90625 
  TCNT0=175;                    //178
    
  while(1)
  {
      //  
  if (PIND.6==0)              //. 
    {
      data_e++;               // 
      if (data_e==10)         //  =10
        {
          data_e=0;           //   0
          data_d++;           //  
        }                         
      delay_ms(200);          //
    } 
    
   if (PIND.5==0)             //.  
      {
      data_e--;               // 
      if (data_e==0)          //  =0
        {    
          data_e=10;         
        }//if2
       if (data_e==9) data_d=data_d-1;
      delay_ms(200);
      }     
    #asm("sei");
   }//while(1)   
}//main
